Subject: Re:TM is_slow_

From: [email-masked] (Christopher Phillips)
Date: Fri, 4 Sep 92 22:02:27 WST

I don't believe Mr Stampe posted his
response to my TM ideas to the entire list,
but as there seem to be a few people wanting
to throw them into r386, I believe it is
appropriate to pass on this message and
my full concurrance that it would be
somewhat counter to the goals of the
project.

> 
> > > * BITMAP OBJECTS and TEXTURE MAPPING
> > > 
> > 
> > Now this lot is fun.  As I understand it, the innermost loop on
...
> > in two stages (render on a bitmap with scandirection perpendicular to
> > normal of surface and then rotate image) or step through source image
> > by increments that are a function of 1/x.
> 
> 
> Even if the texture mapping was just a direct copy, it would be a 8x
> decrement in speed because REND386 writes 4 pixels at once (plus some other)
> overhead.  Why this much?  Because you'd automatically eliminate small
> polys from texture mapping anyway, so you're left with the hit for large
> poly fills.

Admittedly, full texture mapping would slow down the actual screen scribbling
by a factor of 10 or so, and this would decidedly not fit in with what
appear to be the goals of this project: to obtain real time full screen
3d on existing PC technology.

> 
> The texture step is indeed nonlinear: you need a 2-accumulator stepping
> (update dx, update dy, update x, update y) and a LOT of setup math.

Even this would only be an approximation, as the stepping fn has a 1/x term
in it.

> When you don't stick to rectangular, axis-aligned polys (as in Ultima
> Underworld) the setup cost is even greater.  I don't plan to add textures
> in the near future, (nor do I plan to add a "photorealistic" mode-- you can
> save your current configuration and use one of the many freeware renderers
> to do that).
> 

Christopher Jam	__________________________________________________
[email-masked]			c64 forever!!!!
300,000 c64's were sold in the fiscal year ending June 1991 :)
------------------------------------------------------------------